'use strict';

//Card controller
//Retrieves product data and apples to card
//Adds card to swipe stack

angular.module('stashd.menusettings', [])

/*.config(['$stateProvider', '$urlRouterProvider',
    function($stateProvider, $urlRouterProvider) {
        $stateProvider
            .state('cards', {
                url: '',
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/cards/cards.html'
                    }
                }
            });

    }
])*/

.service('UserProfileApi', ['$http', 'CONFIG',
    function($http, CONFIG) {
        var apiUrl = CONFIG.API_URL + '/user/';

        var getApiData = function() {
            return $http.get(apiUrl)
        };
        
        var getGenders = function() {
            return $http.get(CONFIG.API_URL + '/genders/')
        }
        var getRegions = function() {
            return $http.get(CONFIG.API_URL + '/regions/')
        }
        var getCurrencies = function() {
            return $http.get(CONFIG.API_URL + '/currencies/')
        }
        var getLanguages = function() {
            return $http.get(CONFIG.API_URL + '/languages/')
        }
        //var data = JSON.stringify({uid:21, click:1, like:1, removed:1, imagecl:0, scroll:1, clickbuy:0});        
        var postUpdateUser = function(data) {
            return $http.post(apiUrl, data);
        }
        return {
            getApiData: getApiData,
            getGenders: getGenders,
            getRegions: getRegions,
            getCurrencies: getCurrencies,
            getLanguages: getLanguages,
            postUpdateUser: postUpdateUser,
        };
    }]
)
// .directive('noScroll', '$document',
//     function($document) {
//         return {
//             restrict: 'A',
//             link: function($scope, $element, $attr) {

//                 $document.on('touchmove', function(e) {
//                     e.preventDefault();
//                 });
//             }
//         }
//     }
// )

.controller('menusettingsCtrl', function($scope, $log, UserProfileApi,$ionicActionSheet, $ionicLoading,djangoAuth, cardsCache, stylistCardsCache, storeCardsCache, TranslationsService) {
        var loaderTemplate = '<div class="loader-img loader-img-cards"></div>'+
                            '<div class="loader-back"></div>';
        var showLoader = function(content){
            console.log('showing loader');
            $ionicLoading.show({
                template: loaderTemplate,
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                showDelay: 0
            });
        }
        $scope.translations = TranslationsService.getData();
        $scope.model = [];
        showLoader('getting settings data!');
        UserProfileApi.getGenders().then(function(genderResult){
            console.log('genderResult.data',genderResult.data);
            $scope.genders = genderResult.data;
            UserProfileApi.getRegions().then(function(regionResult){
                $scope.regions = regionResult.data;
                UserProfileApi.getCurrencies().then(function(currencyResult){
                    $scope.currencies = currencyResult.data;
                    UserProfileApi.getLanguages().then(function(languageResult){
                        $scope.languages = languageResult.data;
                        UserProfileApi.getApiData().then(function (userProfileResult) {
                            $scope.model = userProfileResult.data;
                            $('.list').show();
                            $ionicLoading.hide();
                        });
                    });
                });
            });
        });
        
        $scope.updateUserSettingsGender = function (){
            UserProfileApi.postUpdateUser(JSON.stringify({id:$scope.model.id, settings_gender: $scope.model.settings_gender}));
            cardsCache.length = 0;
            stylistCardsCache.length = 0;
            storeCardsCache.length = 0;
        };
        $scope.updateUserSettingsRegion = function (){
            UserProfileApi.postUpdateUser(JSON.stringify({id:$scope.model.id,settings_region: $scope.model.settings_region}));
            cardsCache.length = 0;
            stylistCardsCache.length = 0;
            storeCardsCache.length = 0;
        };
        $scope.updateUserSettingsCurrency = function (){
            UserProfileApi.postUpdateUser(JSON.stringify({id:$scope.model.id,settings_currency: $scope.model.settings_currency}));
            cardsCache.length = 0;
            stylistCardsCache.length = 0;
            storeCardsCache.length = 0;
        };
        $scope.updateUserSettingsLanguage = function (){
            UserProfileApi.postUpdateUser(JSON.stringify({id:$scope.model.id,settings_language: $scope.model.settings_language})).then(function(){
                TranslationsService.reloadFromServer();
            });
            cardsCache.length = 0;
            stylistCardsCache.length = 0;
            storeCardsCache.length = 0;
        };
        $scope.showLogOutMenu = function() {
        var hideSheet = $ionicActionSheet.show({
            destructiveText: $scope.translations.logout,
            titleText: $scope.translations.logout_disclaimer,
            cancelText: 'Cancel',
            cancel: function() {},
            buttonClicked: function(index) {
                return true;
            },
            destructiveButtonClicked: function(){
                $ionicLoading.show({
                    template: 'Logging out...'
                });
                // $scope.$on("djangoAuth.logged_out", function(data){
                //     $state.go('login');
                // });
                djangoAuth.logout();

                $ionicLoading.hide();
                
                // Facebook logout
                // facebookConnectPlugin.logout(function(){
                //         $ionicLoading.hide();
                //         $state.go('login');
                //     },
                //     function(fail){
                //         $ionicLoading.hide();
                //     });
                
            }
        });
    };
    }
);