'use strict';
angular.module('stashd.stylists', [])


.factory('stylistsApi', ['$http', 'CONFIG',
    function($http, CONFIG) {
        var apiUrl = CONFIG.API_URL + '/tag/';

         var getApiData = function() {
            return $http.get(apiUrl)
        };

        return {
            getApiData: getApiData
        };
    }]
)
.directive('noScroll', '$document',
    //[ '$document', function($document){}]
    function($document) {
        return {
            restrict: 'A',
            link: function($scope, $element, $attr) {

                $document.on('touchmove', function(e) {
                    e.preventDefault();
                });
            }
        }
    }
)

.controller('stylistsCtrl', ['$scope', '$log', 'stylistsApi', 'UserService', '$state', 'stylistCardsCache', 'TranslationsService',
    function($scope, $log, stylistsApi, UserService, $state, stylistCardsCache, TranslationsService) {
        $scope.translations = TranslationsService.getData();
        $scope.greaterThan = function(prop, val){
        return function(item){
          return item[prop] > val;
        }}
    // $scope.stylists = [];
    // angular.forEach(data.stylists, function(value, key) {
    //     $scope.stylists.data(value);
    // });

    // <======  Rewrite with accounts preferences
    stylistsApi.getApiData()
        .then(function (result) {
            // console.log(JSON.stringify(result.data)) //Shows log of API incoming
            console.log(result.data);
            $scope.stylists = result.data;
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('StylistNameVisit');
        })
        .catch(function (err) {
            $log.error(err);
        });
    $scope.stylistClicked = function(id){
        stylistCardsCache.length = 0;
        $state.go('stylistshop',{stylist_id:id});  
    };
    $scope.refine = function(){
        if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('RefineType');
    }
    // console.log($state)
    // if(['stylists', 'stores'].indexOf($state.current.name) > -1){
        // console.log($scope)
    // }else{
        // console.log(987)
        // $scope.showTabs = false;
        // $scope.$parent.$parent.showTabs = false;
    // }
}
]);