// json data=
// [{"product__name":"Test ","product__pk":231},{"product__name":"Test2 ","product__pk":351}]

'use strict';
angular.module('stashd.wardrobes', [])


.factory('wardrobesApi', ['$http', 'CONFIG',
    function($http,CONFIG) {
        var apiUrl =  CONFIG.API_URL + '/wardrobe/';
        var remove = JSON.stringify({click:0, like:0, removed:1, imagecl:0, scroll:0, clickbuy:0});

        var getApiData = function(num) {
            return $http({
                method: 'GET',
                url: apiUrl + '?page=' + num
            });
        };

        var postRecordremove = function (product_vari) {
            return $http.post(CONFIG.API_URL + '/item/' + product_vari + "/", remove);
        }

        return {
            getApiData: getApiData,
            postRecordremove: postRecordremove,
        };
    }]
)
.directive('noScroll', '$document',
    //[ '$document', function($document){}]
    function($document) {
        return {
            restrict: 'A',
            link: function($scope, $element, $attr) {

                $document.on('touchmove', function(e) {
                    e.preventDefault();
                });
            }
        }
    }
)

.controller('wardrobesCtrl', ['$scope', '$rootScope','$ionicLoading', '$timeout', '$log', 'wardrobesApi', 'UserService', '$ionicListDelegate', 'djangoAuth',
    function($scope, $rootScope, $ionicLoading, $timeout, $log, wardrobesApi, UserService, $ionicListDelegate, djangoAuth) {

    // $scope.wardrobes = [];
    // angular.forEach(data.wardrobes, function(value, key) {
    //     $scope.wardrobes.data(value);
    // });

        $scope.renderwardrobes = new Array();
        $scope.wardrobesavailable = [];
        $scope.wardrobesoutofstock = [];

        $scope.isVisible = function(name){
            return true;// return false to hide this artist's albums
        };

        $scope.remove = function(wardrobe){
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('WardrobeProductDelete');
            $scope.renderwardrobes.splice($scope.renderwardrobes.indexOf(wardrobe), 1);
            postRecordremove(wardrobe.vari);
        }

        $scope.warprovisit = function(id){
            var imgUrl = '';
            $scope.renderwardrobes.map(function(wardrobe){
                if(wardrobe.id == id){
                    $rootScope.defaultProductData.name = wardrobe.name;
                    $rootScope.defaultProductData.images.push(wardrobe.image)
                }
            })
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('WardrobeProductVisit');
        }

        var postRecordremove = function (product_vari) {
            $ionicListDelegate.closeOptionButtons();
            wardrobesApi.postRecordremove(product_vari)
                .then(function successCallback(product_vari) {
                    console.log('remove success',product_vari);
                }, function errorCallback(response) {
                    console.log('remove error',response);
                });
        };

        $scope.closeOtherOpts = function(){
            $ionicListDelegate.closeOptionButtons();
        }


        // <======  Rewrite with accounts preferences
        $scope.fetchDataFromApi = function(pageNo){
            wardrobesApi.getApiData(pageNo)
                .then(function (result) {
                    //console.log('result',result);
                    // TO TEST OUT-OF-STOCK ITEMS ------ start
                    // for (var i = 0; i < result.data.length; i++) {
                    //     if(i%6 == 0){
                    //         result.data[i].image = '/data.jpg';    
                    //     }
                    // }
                    // TO TEST ------ end

                    for (var i = 0; i < result.data.length; i++) {
                        var c = document.createElement('img');
                        c.src = result.data[i].image;
                        c.onload = function(available){

                            $scope.wardrobesavailable.push(available);
                            $scope.renderwardrobes = new Array();
                            $scope.renderwardrobes = $scope.wardrobesavailable.concat($scope.wardrobesoutofstock);
                            $ionicLoading.hide();

                        }.bind(null, result.data[i]);
                        c.addEventListener('error', function(outofstock){

                            outofstock.image = 'assets/img/out-of-stock.png';
                            $scope.wardrobesoutofstock.push(outofstock);
                            $scope.renderwardrobes = new Array();
                            $scope.renderwardrobes = $scope.wardrobesavailable.concat($scope.wardrobesoutofstock);

                        }.bind(null, result.data[i]));

                        // var dummyEl = document.getElementById('dummy-image');
                        // if(dummyEl !== null){
                        //     dummyEl.innerHTML = '';
                        //     dummyEl.appendChild(c);
                        // }
                    }
                    if(result.data.length == 0){
                        $ionicLoading.hide();
                    } 
                    
                    if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('Wardrobe Visit');

                },function (err) {
                    $log.error(err);
                    if(err.status==403){
                        console.log('status 403');
                        $ionicLoading.hide();
                        djangoAuth.logout();
                    } else{
                        console.log('unknown error',err);
                        $ionicLoading.hide();
                    }
                });
        }
        $scope.fetchDataFromApi(1);



        var loaderTemplate = '<div class="loader-img loader-img-wardrobe"></div>'+
                            '<div class="loader-back"></div>';

        var showLoader = function(content){
            $ionicLoading.show({
                template: loaderTemplate,
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                showDelay: 0
            });
        }

        showLoader();

        $(function(){
            $timeout(function(){

                var num = 2;
                while(num < 20)
                {
                    $scope.fetchDataFromApi(num);
                    num++;
                }
                
            }, 2000);
        
        });

    

    }]);
