angular.module('stashd.card-demo', ['stashd.utils'])

.config(function($stateProvider, $urlRouterProvider) {

})
.value('cardsCache',[])
.directive('noScroll', function($document) {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $document.on('touchmove', function(e) {
                e.preventDefault();
            });
        }
    }
})
//Below analytics needs to be much smarter/better. Should be able to 'update' products, and add to
// numbers. Need to also 'track' movement better. Track js movement?
.factory('carddemoApi', ['$http', '$ionicLoading', '$timeout', 'CONFIG', function($http, $ionicLoading, $timeout, CONFIG) {
    var apiUrl = CONFIG.API_URL + '/list/?608';
    var getApiData = function() {
        return $http({
            method: 'GET',
            url: apiUrl
        });
    };
    var like = JSON.stringify({
        click: 1,
        like: 1,
        imagecl: 0,
        removed: 0,
        scroll: 1,
        clickbuy: 0
    });
    var dislike = JSON.stringify({
        click: 0,
        like: 0,
        imagecl: 0,
        removed: 0,
        scroll: 0,
        clickbuy: 0
    });

    var postdemoRecordLikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/demoitem/' + product_vari + "/", like);
    }

    var postdemoRecordDislikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/demoitem/' + product_vari + "/", dislike);
    }
    return {
        getApiData: getApiData,
        postdemoRecordLikes: postdemoRecordLikes,
        postdemoRecordDislikes: postdemoRecordDislikes,
    };
}])

.controller('CarddemoCtrl', ['$scope', '$rootScope', '$http', '$state', '$q', '$ionicLoading', '$ionicModal', 'TDCardDelegate', 'carddemoApi', '$timeout', '$element', 'djangoAuth', 'cardsCache', 'TranslationsService', '$ionicPopup',
    function($scope, $rootScope, $http, $state, $q, $ionicLoading, $ionicModal, TDCardDelegate, carddemoApi, $timeout, $element, djangoAuth, cardsCache, TranslationsService, $ionicPopup) {
        TranslationsService.reloadFromServer();
        $scope.translations = TranslationsService.getData();

        $scope.cardSwipedRight = function(card) {
            postdemoRecordLikes(card);
        };
    var postdemoRecordLikes = function(product_vari) {
            carddemoApi.postdemoRecordLikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    if(response.status == 404){
                        $scope.$on("$destroy", function(event){
                            $scope.$destroy();
                        });
                    }
                });
        };
        $scope.cardTrash = function(){
            // console.log('cardid',cardid);
            $scope.$parent.cardDestroyed($scope.$parent.cards.length - 1);
            postdemoRecordDislikes($scope.$parent.cards[$scope.$parent.cards.length - 1].id);
        }
        $scope.cardStash = function(){
            // console.log('cardid',cardid);
            $scope.$parent.cardDestroyed($scope.$parent.cards.length - 1);
            postdemoRecordLikes($scope.$parent.cards[$scope.$parent.cards.length - 1].id);
        }
        $scope.cardDestroyed = function(index) {
            console.log('destroyed in directive at index : ' + index);
            $scope.$parent.cardDestroyed(index);
        };

        $scope.cardSwipedLeft = function(card) {
            postdemoRecordDislikes(card);
        };

        var postdemoRecordDislikes = function(product_vari) {
            carddemoApi.postdemoRecordDislikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    // console.log(response);
                    
                });
        };

        $scope.cardevent = function(id) {
            var imgUrl = '';
            $scope.cards.map(function(card){
                if(card.id == id){
                    console.log('setting default product data');
                    $rootScope.defaultProductData.name = card.name;
                    $rootScope.defaultProductData.images.push(card.image)
                }
            })
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('CardClick');
        }

                $scope.cardDestroyed = function(index) {
            // console.log('destroyed in cards.js at index : ' + index);
            // console.log('we now have ' + $scope.cards.length + ' cards');
            // $scope.cards.splice(index, 1);
            // fetchMoreIfNeeded();
        };

   $scope.storeAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
       title: '啊哟？您还没有登录呢',
       template: ' 请登录，浏览您最爱的店铺'
     });
   };
   $scope.wardrobeAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
        template: '<a href="/#/login"><button id="index-button2" class="button button-dark  button-small icon">Login</button></a>',
       title: '啊哟？您还没有登录呢',
       template: '请登录，把您喜爱的商品存入虚拟衣橱'
     });
   };

        
        console.log('CARDS CTRL - cardsCache : ', cardsCache.length);
        var MIN_CARDS = 10;

        

        var loaderTemplate = '<div class="loader-img loader-img-cards"></div>'+
                            '<div class="loader-back"></div>';

        var showLoader = function(content){
            console.log('showing loader');
            $ionicLoading.show({
                template: loaderTemplate,
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                showDelay: 0
            });
        }

        showLoader('fetch more!');
        var fetchInProgress = false;
        var fetchAPIData = function() {
            console.log('fetchAPIData called');
            if(!fetchInProgress){
                fetchInProgress = true;
                carddemoApi.getApiData().then(function(result) {
                    console.log('fetchedCards',result);
                    // var cards = response.data;
                    if(result.data.length == 0){
                        $ionicLoading.hide();
                        fetchInProgress = false;
                        return;
                    }
                    for (var i = 0; i < result.data.length; i++) {
                        var c = document.createElement('img');
                        c.src = result.data[i].image;
                        c.onload = function(available){
                            $scope.cards.unshift(available);
                            $ionicLoading.hide();
                            //if last one and still there's 
                            if(i==result.data.length-1){
                                
                            }
                        }.bind(null, result.data[i]);

                        c.addEventListener('error', function(errorImg){
                            // to check for those imgs which are not loaded
                        }.bind(null, result.data[i]));

                        // var dummyEl = document.getElementById('dummy-image-card');
                        // if(dummyEl !== null){
                        //     dummyEl.innerHTML = '';
                        //     dummyEl.appendChild(c);
                        // }
                    }
                    fetchInProgress = false;
                    //below is to ensure that if all newly loaded items has no image, we want to trigger another batch of items straight away.
                    setTimeout(function(){
                        fetchMoreIfNeeded();    
                    },3000);
                }, function(err){
                    fetchInProgress = false;
                    if(err.status==403){
                        console.log('status 403');
                        $ionicLoading.hide();
                        djangoAuth.logout();
                    } else if(err.status==401){
                        console.log('status 401');
                        $ionicLoading.hide();
                        djangoAuth.logout();
                    }else{
                        console.log('unknown error',err);
                        $ionicLoading.hide();
                    }
                });
            }
        }
//DISABLED TO stop the reloading of cards (ie only will see 10)
        // $scope.cardDestroyed = function(index) {
        //     console.log('destroyed in cards.js at index : ' + index);
        //     console.log('we now have ' + $scope.cards.length + ' cards');
        //     $scope.cards.splice(index, 1);
        //     fetchMoreIfNeeded();
        // };

        function fetchMoreIfNeeded() {
            if ($scope.cards.length < MIN_CARDS) {
                console.log('we need more cards, fetching more');
                if($scope.cards.length == 0){
                    showLoader('fetch more!');
                }
                fetchAPIData();
            } else{
                $ionicLoading.hide();
            }
        }
        $scope.addCard = function() {
            var newCard = $scope.cards[$scope.cards.length];
            $scope.cards.push(angular.extend({}, newCard));
        };
        var stressTestCounter = 0;
        function cardFetchingStressTest(counter) {
            $ionicLoading.hide();
            var startTime = Date.now();
            console.log('sending fetching order(' + counter + ')');
            carddemoApi.getApiData().then(function(result) {
                console.log('fetched cards(' + counter + ') : ' + (Date.now()-startTime)/1000 + ' secs');
            }, function(err){
                if(err.status==403){
                    console.log('fetching error status 403(' + counter + ')' + (Date.now()-startTime)/1000 + ' secs');
                    djangoAuth.logout();
                } else if(err.status==401){
                    console.log('fetching error status 401(' + counter + ')' + (Date.now()-startTime)/1000 + ' secs');
                    djangoAuth.logout();
                }else{
                    console.log('fetching error unknown error(' + counter + ')' + (Date.now()-startTime)/1000 + ' secs',err);
                }
            });
            if(counter==10){
                return;
            }
            setTimeout(function(){
                stressTestCounter ++;
                cardFetchingStressTest(stressTestCounter);
            },2000);
        }
        setTimeout(function(){
            $scope.cards = cardsCache;
            fetchMoreIfNeeded();
            //cardFetchingStressTest(stressTestCounter);
        },400);
    }
])
.directive('ngIf', function() {
    return {
        link: function(scope, element, attrs) {
            if(scope.$eval(attrs.ngIf)) {
                // remove '<div ng-if...></div>'
                //element.replaceWith(element.children())
            } else {
                element.replaceWith(' ');
            }
        }
    }
});