'use strict';
angular.module('stashd.store-demo', [])


.factory('storedemoApi', ['$http', 'CONFIG',
    function($http, CONFIG) {
        var apiUrl = CONFIG.API_URL + '/store/?608';

         var getApiData = function() {
            return $http.get(apiUrl)
        };

        return {
            getApiData: getApiData
        };
    }]
)
.directive('noScroll', '$document',
    //[ '$document', function($document){}]
    function($document) {
        return {
            restrict: 'A',
            link: function($scope, $element, $attr) {

                $document.on('touchmove', function(e) {
                    e.preventDefault();
                });
            }
        }
    }
)

.directive('swiper', function($timeout) {
    return {
        link: function(scope, element, attr) {
            //on ng-repeat change notification
            scope.$on('content-changed', function() {
                console.log('content-changed called'); 
                var swiper = new Swiper('.swiper-container', {
                    pagination: '.swiper-pagination',
                    effect: 'coverflow',
                    grabCursor: false,
                    centeredSlides: true,
                    slidesPerView: 'auto',
                    loop: false,
                    nested: false,
                    // bulletClass: 'swiper-bullet-style',
                    //bulletActiveClass: 'swiper-active-bullet-style',
                    //freeMode: true,
                    // width: 200,
                    // height: 200,
                    // spaceBetween: 10,
                    // slidesOffsetBefore: 10,
                    // slidesOffsetAfter : 10,
                    coverflow: {
                        rotate: 50,
                        stretch: 0,
                        depth: 100,
                        modifier: 1,
                        slideShadows : true
                    }
                });   
                swiper.slideTo(1,200,false);
                //swiper.slideTo(0,200,false);     
            });
        }
    };
})
.controller('storedemoCtrl', ['$scope', '$log', 'storedemoApi', 'UserService', '$ionicModal', '$state', 'storeCardsCache', 'TranslationsService', '$ionicPopup',
    function($scope, $log, storedemoApi, UserService, $ionicModal, $state, storeCardsCache, TranslationsService, $ionicPopup) {
        $scope.translations = TranslationsService.getData();
        // $scope.stores = [];
        // angular.forEach(data.stores, function(value, key) {
        //     $scope.stores.data(value);
        // });
        console.log('hello');
           $scope.storeAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
       title: '啊哟？您还没有登录呢',
       template: ' 请登录，浏览您最爱的店铺'
     });
   };
        $scope.featureClicked = function(id){
            storeCardsCache.length = 0;
            $state.go('storeshop',{store_id:id});  
        };
        $scope.tileClicked = function(id){
            storeCardsCache.length = 0;
            $state.go('storeshop',{store_id:id});  
        };
        $scope.isVisible = function(name){
            return true;// return false to hide this artist's albums
        };
        $scope.greaterThan = function(prop, val){
        return function(item){
          return item[prop] > val;
        }}

        // <======  Rewrite with accounts preferences
        storedemoApi.getApiData()
            .then(function (result) {
                console.log('returnedData',result.data);
                $scope.stores = result.data;
                $scope.store_pk = result.data.store_pk;

                if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('StoreVisit');        
            })
            .catch(function (err) {
                $log.error(err);
            });

        $scope.refinetype = function(){
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('RefineType');
        }
        
        
    }
    
]);