'use strict';
angular.module('stashd.stylist-demo', [])


.factory('stylistdemoApi', ['$http', 'CONFIG',
    function($http, CONFIG) {
        var apiUrl = CONFIG.API_URL + '/tag/?608';

         var getApiData = function() {
            return $http.get(apiUrl)
        };

        return {
            getApiData: getApiData
        };
    }]
)
.directive('noScroll', '$document',
    //[ '$document', function($document){}]
    function($document) {
        return {
            restrict: 'A',
            link: function($scope, $element, $attr) {

                $document.on('touchmove', function(e) {
                    e.preventDefault();
                });
            }
        }
    }
)

.controller('stylistdemoCtrl', ['$scope', '$log', 'stylistdemoApi', 'UserService', '$state', 'stylistCardsCache', 'TranslationsService', '$ionicPopup',
    function($scope, $log, stylistdemoApi, UserService, $state, stylistCardsCache, TranslationsService, $ionicPopup) {
        $scope.translations = TranslationsService.getData();
        $scope.greaterThan = function(prop, val){
        return function(item){
          return item[prop] > val;
        }}
                   $scope.stylistAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
       title: '啊哟？您还没有登录呢',
       template: '请登录，浏览我们的设计师推荐系列'
     });
   };
    // $scope.stylists = [];
    // angular.forEach(data.stylists, function(value, key) {
    //     $scope.stylists.data(value);
    // });

    // <======  Rewrite with accounts preferences
    stylistdemoApi.getApiData()
        .then(function (result) {
            // console.log(JSON.stringify(result.data)) //Shows log of API incoming
            console.log(result.data);
            $scope.stylists = result.data;
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('StylistNameVisit');
        })
        .catch(function (err) {
            $log.error(err);
        });
    $scope.stylistClicked = function(id){
        stylistCardsCache.length = 0;
        $state.go('stylistshop',{stylist_id:id});  
    };
    $scope.refine = function(){
        if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('RefineType');
    }
    // console.log($state)
    // if(['stylists', 'stores'].indexOf($state.current.name) > -1){
        // console.log($scope)
    // }else{
        // console.log(987)
        // $scope.showTabs = false;
        // $scope.$parent.$parent.showTabs = false;
    // }
}
]);