angular.module('stashd.utils', [])
.factory('cardIonPaneApi', ['$http', 'CONFIG', function($http, CONFIG) {
    var apiUrl = CONFIG.API_URL + '/list/';
    var like = JSON.stringify({
        click: 1,
        like: 1,
        imagecl: 0,
        removed: 0,
        scroll: 1,
        clickbuy: 0
    });
    var dislike = JSON.stringify({
        click: 0,
        like: 0,
        imagecl: 0,
        removed: 0,
        scroll: 0,
        clickbuy: 0
    });

    var postRecordLikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/item/' + product_vari + "/", like);
    }

    var postRecordDislikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/item/' + product_vari + "/", dislike);
    }

    return {
        postRecordLikes: postRecordLikes,
        postRecordDislikes: postRecordDislikes,
    };
}])
.directive('cardIonPane', [ function() {

	var linker = function(scope, element, attrs){
		scope.$watchCollection('cards', function() {
		})
	}

	return {
		restrict: 'E',
		replace: true,
		link: linker,
		templateUrl: 'app/core/directives/card-directive.htm',
		controller: 'cardIonPaneCtrl',
		scope:{
			cards: '=',
			logo: '='
		}
	};
}])
.controller('cardIonPaneCtrl', ['$scope', '$rootScope', 'cardIonPaneApi', 'TranslationsService', 'BadgeService',
	function($scope, $rootScope, cardIonPaneApi,TranslationsService, BadgeService){
        $scope.showBadge = !BadgeService.isBadgeDismissed();
        console.log('$scope.showBadge',$scope.showBadge);
        $scope.s_icon_clicked = function(){
            console.log('s icon clicked');
            if(!BadgeService.isBadgeDismissed()){
                BadgeService.dismissBadge();
                $scope.showBadge = false;
            }
        };
        $scope.translations = TranslationsService.getData();
        $('img.title-image').css('display','block');
		$scope.cardSwipedRight = function(card) {
            postRecordLikes(card);
        };

        var postRecordLikes = function(product_vari) {
            cardIonPaneApi.postRecordLikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    if(response.status == 404){
                        $scope.$on("$destroy", function(event){
                            $scope.$destroy();
                        });
                    }
                });
        };
        $scope.cardTrash = function(){
            // console.log('cardid',cardid);
            $scope.$parent.cardDestroyed($scope.$parent.cards.length - 1);
            postRecordDislikes($scope.$parent.cards[$scope.$parent.cards.length - 1].id);
        }
        $scope.cardStash = function(){
            // console.log('cardid',cardid);
            $scope.$parent.cardDestroyed($scope.$parent.cards.length - 1);
            postRecordLikes($scope.$parent.cards[$scope.$parent.cards.length - 1].id);
        }
        $scope.cardDestroyed = function(index) {
            console.log('destroyed in directive at index : ' + index);
        	$scope.$parent.cardDestroyed(index);
        };

        $scope.cardSwipedLeft = function(card) {
            postRecordDislikes(card);
        };

        var postRecordDislikes = function(product_vari) {
            cardIonPaneApi.postRecordDislikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    // console.log(response);
                    
                });
        };

        $scope.cardevent = function(id) {
            var imgUrl = '';
            $scope.cards.map(function(card){
                if(card.id == id){
                    console.log('setting default product data');
                    $rootScope.defaultProductData.name = card.name;
                    $rootScope.defaultProductData.images.push(card.image)
                }
            })
            if(typeof window.plugins !== "undefined" && typeof window.plugins.flurry !== "undefined") window.plugins.flurry.logEvent('CardClick');
        }

	}])
