'use strict';

angular.module('stashd.forgotpassword', [])

.controller('ForgotPasswordController', function($scope, $state, $q, UserService, $ionicLoading, $log, djangoAuth,$ionicPopup, TranslationsService, ServerLocatorService) {
    if(ServerLocatorService.getCurrentCountryCode() == 'CN'){
        $('.hide-for-chinese').hide();
    } else{
        $('.hide-for-chinese').show();
    }
    $scope.translations = TranslationsService.getData();
    //hiding the navigation toolbar's title image
    $('img.title-image').css('display','none');

    $scope.model = {email:''}
    //StatusBar.hide(); ### Need to install ngCordova Status Bar
    $scope.resetPassword = function(){
        $scope.errors = [];
        console.log('password reset email', $scope.model.email);
        djangoAuth.resetPassword($scope.model.email)
        .then(function(data){
            console.log('reset pass request success',data);
            
            // success case
            $scope.complete = true;
            var alertPopup = $ionicPopup.alert({
                title: 'Success',
                template: data.success
            });

            alertPopup.then(function(res) {
                $state.go('login');
            });
            
        },function(data){
            console.log('reset pass request failure',data);
            // error case
            $scope.errors = data;
            var alertPopup = $ionicPopup.alert({
                title: 'Error',
                template: data.error
            });

            alertPopup.then(function(res) {
            });
        });
    }

})

.directive('loginView', ['$document',
    function($document) {
        return {
            restrict: 'E',
            templateUrl: 'app/core/login/login.html',
            link: function($scope, $element, $attr) {
            }
        }

    }
])

;
