'use strict';

angular.module('stashd.loginemail', [])

.controller('LoginEmailController', function($scope, $state, $q, UserService, $ionicLoading, $log, djangoAuth, $ionicPopup, TranslationsService, ServerLocatorService) {
    if(ServerLocatorService.getCurrentCountryCode() == 'CN'){
        $('.hide-for-chinese').hide();
    } else{
        $('.hide-for-chinese').show();
    }
    $scope.translations = TranslationsService.getData();
    //hiding the navigation toolbar's title image
    $('img.title-image').css('display','none');
    //StatusBar.hide(); ### Need to install ngCordova Status Bar
    $scope.model = {'username':'','password':''};
    $scope.buttonDisabled = false;
    $scope.complete = false;
    $scope.login = function(){
        $scope.buttonDisabled = true;
        $scope.errors = [];
        // console.log('sending ',$scope.model);
        $scope.$on("djangoAuth.logged_out", function(data){
            $state.go('cards');
        });
        djangoAuth.login($scope.model.username, $scope.model.password)
        .then(function(data){
            // success case
            //$state.go('cards' {uid: uid});
            // $scope.$on("djangoAuth.logged_in", function(data){
            //     $state.go('cards');
            // });
            $scope.buttonDisabled = false;
            $state.go('cards');             
            
        },function(data){
            $scope.buttonDisabled = false;
            console.log('login failed',data);
            $ionicPopup.alert({
                title: 'Login failed',
                template: $scope.translations.login_failed_popup_accountpage
            });

            // alertPopup.then(function(res) {
            //     console.log('Thank you for not eating my delicious ice cream cone');
            // });
            // error case
            $scope.buttonDisabled = false;
            $scope.errors = data;
        });
    }
})



