'use strict';

angular.module('stashd.registeropt', [])

.controller('RegisterOptController', ['$scope','$state','$q','RegisterService', 'djangoAuth', '$ionicPopup', 'UserProfileApi', 'TranslationsService', 'ServerLocatorService',
    function($scope, $state, $q, RegisterService, djangoAuth, $ionicPopup, UserProfileApi, TranslationsService, ServerLocatorService) {
        if(ServerLocatorService.getCurrentCountryCode() == 'CN'){
            $('.hide-for-chinese').hide();
        } else{
            $('.hide-for-chinese').show();
        }
        $scope.translations = TranslationsService.getData();
        //hiding the navigation toolbar's title image
        $('img.title-image').css('display','none');

        //StatusBar.hide(); ### Need to install ngCordova Status Bar
        $scope.dobYears = [];
        var x;
        var d = new Date();
        var currentYear = d.getFullYear();
        for(x=currentYear;x>=1900;x--){
            $scope.dobYears.push(x);
        };
        $scope.genderClicked = function(gender){
            $scope.model.gender = gender;
        };
        $scope.model = {'yob':'', 'gender':''};
        $scope.complete = false;
        $scope.buttonDisabled = false;
        $scope.updateUserSettingsGender = function (id){
            
        };
        $scope.updateUserYOB = function (id){
            
        };
        $scope.register = function(skipOptionalFields){
            //console.log('formData',formData);
            $scope.buttonDisabled = true;
            $scope.errors = [];
            var savedUserData = RegisterService.getUserData();
            console.log('savedUserData',savedUserData);

            djangoAuth.register(savedUserData.password,savedUserData.password,savedUserData.email,$scope.model)
            .then(function(data){
                //now the account is created.
                //updating the YOB and gender

                console.log('data from register',data)
                // success case
                $scope.complete = true;
                //try login straight after.
                console.log('logging in with ', savedUserData.email, savedUserData.password);
                djangoAuth.login(savedUserData.email, savedUserData.password)
                .then(function(data){
                    if(skipOptionalFields){
                        UserProfileApi.getApiData().then(function (result) {
                            console.log("user data", result);
                            console.log('updating gender and yob');
                            var genderId = '3';
                            UserProfileApi.postUpdateUser(JSON.stringify({id:result.data.id, gender: genderId, settings_gender: genderId })).then(function(){
                                    //successful
                            });
                        });
                    }
                    else{
                        UserProfileApi.getApiData().then(function (result) {
                            console.log("user data", result);
                            console.log('updating gender and yob');
                            var genderId = '3';
                            if($scope.model.gender){
                                genderId = $scope.model.gender == 'Male' ? '1' : '2';
                            }
                            console.log('gender selected ' + genderId);
                            UserProfileApi.postUpdateUser(JSON.stringify({id:result.data.id, yob: $scope.model.yob, gender: genderId, settings_gender: genderId })).then(function(){
                                    //successful
                            });
                        });
                    }
                    // success case
                    //$state.go('cards' {uid: uid});
                    $scope.buttonDisabled = false;
                    $state.go('cards');
                },function(data){
                    $scope.buttonDisabled = false;
                    console.log('login failed',data);
                    $ionicPopup.alert({
                        title: 'Something went wrong',
                        template: 'Registraiton was successful but could not log you in.'
                    });

                    // alertPopup.then(function(res) {
                    //     console.log('Thank you for not eating my delicious ice cream cone');
                    // });
                    // error case
                    $scope.errors = data;
                });
            },function(data){
                $scope.buttonDisabled = false;
                console.log('error from register',data)
                // error case
                $scope.errors = data;
                var errorMsg = 'Unable to register.';
                if(data && data.email){
                    errorMsg = data.email[0];
                }
                $ionicPopup.alert({
                    title: 'Registration failed',
                    template: errorMsg
                });
            });
        }
}])

.directive('loginView', ['$document',
    function($document) {
        return {
            restrict: 'E',
            templateUrl: 'app/core/login/login.html',
            link: function($scope, $element, $attr) {
            }
        }

    }
])

;


