'use strict';
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in cards.html)
// the 2nd parameter is an array of 'requires'
var stashd = angular.module('stashd', [

    //Dependency modules
    'ionic',
    'ngRoute',
    'ngAnimate',
    'ngMessages',
    'ionic.contrib.ui.tinderCards',
    
    //App modules
    'stashd.config',
    'stashd.routes',
    'stashd.menusettings',
    'stashd.cards',
    'stashd.mainNav',
    'stashd.login',
    'stashd.loginemail',
    'stashd.intro',
    'stashd.registeropt',
    'stashd.forgotpassword',
    'stashd.wardrobes',
    'stashd.stylists',
    'stashd.products',
    'stashd.stores',
    'stashd.storeshop',
    'stashd.stylistshop',
    'stashd.cardstest',
    'stashd.buynow',
    'stashd.card-demo',
    'stashd.store-demo',
    'stashd.stylist-demo',
    'stashd.modal',
    'stashd.logout',
    'ionic-native-transitions',
    'angularDjangoRegistrationAuthApp',
]) 
.directive('isLoaded', function (){

   return{
     scope:false, //don't need a new scope
     restrict: 'A', //Attribute type
     link: function (scope, elements, attr){ 

        if (scope.$last) {
            
            scope.$emit('content-changed');
            console.log('page Is Ready!');
        }
     }   
   }
})
.run(function($ionicPlatform, $rootScope, $state) {


   $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){
        var toRoutesWithNoHeader = ['product', 'wardrobes', 'intro', 'menusettings','cards', 'storeshop', 'stylistshop', 'loginemail','registeropt','forgotpassword', 'card-demo'];
        var fromRoutesWithNoHeader = ['product', 'login', 'intro',];
        var routesWithTabs     = []; //var routesWithTabs     = ['stores', 'stylists'];
        
        if(routesWithTabs.indexOf(toState.name) > -1){
            $rootScope.showTabs = true;
            if(window.plugins && window.plugins.nativepagetransitions){
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsBottom = 40;
            }
        }else{
            $rootScope.showTabs = false;
            if(window.plugins && window.plugins.nativepagetransitions){
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsBottom = 0;
            }
        }

        if(toRoutesWithNoHeader.indexOf(toState.name) > -1){
            if(window.plugins && window.plugins.nativepagetransitions){
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop = 0;
            }
        }else{
            if(window.plugins && window.plugins.nativepagetransitions){
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop = 44;
            }
        }

        if(fromRoutesWithNoHeader.indexOf(fromState.name) > -1){
            if(window.plugins && window.plugins.nativepagetransitions){
                window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop = 0;
            }
        }

        console.log('fromRoute: '+ fromState.name + ' toState: ' + toState.name );
        if(window.plugins && window.plugins.nativepagetransitions){
            console.log('topPx: '+ window.plugins.nativepagetransitions.globalOptions.fixedPixelsTop + ' bottomPx: '+ window.plugins.nativepagetransitions.globalOptions.fixedPixelsBottom);
        }
        $rootScope.activeRoute = toState.name;
    });

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      //window.plugins.flurry.logEvent('Wardrobe Clicked');
    }
    // if(window.StatusBar) {
    //     StatusBar.styleDefault();
    //     setInterval(function() {
    //         var img = new Image();
    //         img.src = "http://i.stack.imgur.com/GnAR9.png?s=128&g=1"
    //         img.onload=function(){$(img).fadeIn(500);}
    //         img.style.display="none";
    //         document.getElementById('parent').appendChild(img);
    //     }, 500);
    // }
    if(window.StatusBar) {
      StatusBar.overlaysWebView(true);
      StatusBar.styleDefault();
    }
  });

})


//.config(function($locationProvider) {
//    $locationProvider.html5Mode({
//        enabled: true,
//        requireBase: false
//    });
//})


//DISABLE BACK DRAG/SWIPES
.config(function($ionicConfigProvider) {
$ionicConfigProvider.views.swipeBackEnabled(false);
})

// Disable the default page transitions
.config(function($ionicConfigProvider) {
  $ionicConfigProvider.views.transition('none');
})


// .config(function($ionicConfigProvider) {
//   $ionicConfigProvider.views.maxCache(0);
// })

.config(function($ionicNativeTransitionsProvider){
    $ionicNativeTransitionsProvider.setDefaultOptions({
        duration: 400, // in milliseconds (ms), default 400,
        slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
        iosdelay: -1, // ms to wait for the iOS webview to update before animation kicks in, default -1
        androiddelay: -1, // same as above but for Android, default -1
        winphonedelay: -1, // same as above but for Windows Phone, default -1,
        fixedPixelsTop: 44, // the number of pixels of your fixed header, default 0 (iOS and Android)
        fixedPixelsBottom: 0, // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
        triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
        backInOppositeDirection: true // Takes over default back transition and state back transition to use the opposite direction transition to go back
    })
    $ionicNativeTransitionsProvider.setDefaultTransition({
        type: 'slide',
        direction: 'down'
    });
    $ionicNativeTransitionsProvider.setDefaultBackTransition({
        type: 'slide',
        direction: 'right'
    });
    $ionicNativeTransitionsProvider.enable(true);
})
.service('BadgeService', function() {
        // Store user data on ionic local storage
        //window.localStorage.setItem('badgeDismissed','false');
        var badgeDismissed = false;
        if(window.localStorage.getItem('badgeDismissed')!=null){
            badgeDismissed = window.localStorage.getItem('badgeDismissed')=='true';
        }
                 
        var dismissBadge = function(){
            badgeDismissed = true;
            window.localStorage.setItem('badgeDismissed','true');
        }
        
        var isBadgeDismissed = function() {
            console.log('is badge dismissed ? : ', badgeDismissed);
            return badgeDismissed;
        }

        return {
            dismissBadge: dismissBadge,
            isBadgeDismissed: isBadgeDismissed
        };
    }
)
.factory('ServerLocatorService', ['$q', '$http', 'CONFIG', 
    function($q, $http, CONFIG) {
        // $.getJSON('http://ipinfo.io', function(data){
        //     console.log(data)
        // })
        var testWithChinaServer = false;
        var currentCountryCode = 'US';
        var serverLocatorLoaded = $q.defer();
        $.getJSON('http://ipinfo.io',function (data) {
            //console.log('data.country',data.country);
            if(testWithChinaServer){
                currentCountryCode = 'CN';
            } else{
                currentCountryCode = data.country;    
            }
            
            if(currentCountryCode=="CN"){
                CONFIG.API_URL = "http://stashd.chinacloudapp.cn/api";
                //CONFIG.API_URL = "http://stashdapp-t51va1o0.cloudapp.net/api";
                console.log('CONFIG.API_URL',CONFIG.API_URL);
            } else{
                //CONFIG.API_URL = "http://stashd.chinacloudapp.cn/api";
                CONFIG.API_URL = "http://stashdapp-t51va1o0.cloudapp.net/api";
                console.log('CONFIG.API_URL',CONFIG.API_URL);
            }
            
            // CONFIG.API_URL = 'http://127.0.0.1:8000/api';

            var httpGetUrl = CONFIG.API_URL + '/user/genders/';
            $http.get(httpGetUrl, { timeout: 7000 })
                .then( 
                    function successCallback(data){
                        console.log('successCallback', data);
                        serverLocatorLoaded.resolve();
                    }, 
                    function errorCallback(error){
                        console.log('errorCallback', error);
                        
                        if(currentCountryCode=="CN"){
                            // CONFIG.API_URL = "http://stashd.chinacloudapp.cn/api";
                            CONFIG.API_URL = "http://stashdapp-t51va1o0.cloudapp.net/api";
                            console.log('CONFIG.API_URL',CONFIG.API_URL);
                        } else{
                            CONFIG.API_URL = "http://stashd.chinacloudapp.cn/api";
                            // CONFIG.API_URL = "http://stashdapp-t51va1o0.cloudapp.net/api";
                            console.log('CONFIG.API_URL',CONFIG.API_URL);
                        }  
                        serverLocatorLoaded.resolve();
                    });  
                              
        });
        var getCurrentCountryCode = function(){
            return currentCountryCode;
        }
        return {
            getCurrentCountryCode: getCurrentCountryCode,
            serverLocatorLoaded: serverLocatorLoaded.promise,
        };
    }]
)



.run(function($ionicPlatform, $ionicPopup, TranslationsService) {
     $ionicPlatform.onHardwareBackButton(function () {
      if(true) { 

         $ionicPopup.confirm({
             title: '退出',
             template:   '您确定要退出吗？'
         }).then(function(res){
             if( res ){
               navigator.app.exitApp();
             }
         })
      }
   })
})
.factory('TranslationsService', ['$q','$http', 'CONFIG', 'ServerLocatorService',
    function($q, $http, CONFIG,ServerLocatorService) {
        var apiUrl = CONFIG.API_URL + '/translations/';
        var translationsData = {};
        var translationsLoaded = $q.defer();
        ServerLocatorService.serverLocatorLoaded.then(function(){
            var curCountryCode = ServerLocatorService.getCurrentCountryCode();
            console.log('curCountryCode : ' + curCountryCode);
            apiUrl = CONFIG.API_URL + '/translations/';
            $http.get(apiUrl).success(function (data) {
                console.log('Translations data fetched fresh from server',data);
                data.forEach(function(element, index, array){
                    translationsData[element.key] = element.value;
                });
                translationsLoaded.resolve();
            });
        });
        var reloadFromServer = function() {
            $http.get(apiUrl).success(function (data) {
                console.log('Translations data reloaded fresh from server',data);
                data.forEach(function(element, index, array){
                    translationsData[element.key] = element.value;
                });
            });
        }
        var getData = function() {
            return translationsData;
        }
        return {
            translationsLoaded: translationsLoaded.promise,
            getData: getData,
            reloadFromServer: reloadFromServer
        };
    }]
)
.controller('MainNavController', ['$scope', '$rootScope', '$state', '$ionicHistory', '$ionicPlatform', 'djangoAuth', '$ionicNavBarDelegate', function($scope, $rootScope, $state, $ionicHistory, $ionicPlatform, djangoAuth, $ionicNavBarDelegate){
    $scope.$on('djangoAuth.logged_out', function() {
      $scope.authenticated = false;
    });
    // Wait and respond to the log in event.
    $scope.$on('djangoAuth.logged_in', function() {
      $scope.authenticated = true;
    });
    var routesWithHanger = ['cards', 'cardstest', 'storeshop', 'stylistshop'];
    var routesWithoutBackBtn = ['cards', 'cardstest'];
    var routesWithFullScreen = ['product', 'stores', 'stylists'];
    $rootScope.defaultProductData = {
                                name: '',
                                images: []
                            };
var push = new Ionic.Push();

push.register(function(token) {
  push.saveToken(token);
});

    $scope.modalIsShown = false;

    $scope.$on('MODAL_IS_HIDDEN', function() {
        $scope.modalIsShown = false;  
        $scope.hangerIsShown = true;     
        $scope.backBtnIsShown = false;
    });

    $scope.$on('MODAL_IS_SHOWN', function() {
        $scope.modalIsShown = true;
        $scope.hangerIsShown = false;     
        $scope.backBtnIsShown = true;
    });

    $scope.handleLeftNavClick = function(){
        if(!$scope.backBtnIsShown){
            $state.go('menusettings');
            console.log('menusettings');
        }else if($scope.modalIsShown){
            $rootScope.$broadcast('HIDE_MODAL');
            console.log('hidemodal');
        }else{
            $scope.handleBackBtn();
            console.log('back');
        }
    }

    $scope.handleBackBtn = function(){
        //$ionicHistory.goBack(-1);
        $ionicNavBarDelegate.back();
    }

    $scope.hangerClick = function(){
        if($scope.hangerIsShown){
            $state.go('wardrobes');
        }else{
            
        }
    }

    $scope.handleViewContainerTop = function(){
        var viewContainer = angular.element('.view-container')[0];
        if(routesWithFullScreen.indexOf($scope.activeRoute) > -1){
            viewContainer.style.top = 0;
            viewContainer.style.height = 'calc(100% - 0px)';
        }else{
            viewContainer.style.top = 44+'px';
            viewContainer.style.height = 'calc(100% - 44px)';
        }
        
        // if(['wardrobes'].indexOf($scope.activeRoute) > -1){
        //     viewContainer.style.height = 'calc(100% - 44px)';
        // }else{
        //     viewContainer.style.height = 'calc(100% - 0px)';
        // }
    }

 
    $rootScope.$watch('activeRoute', function(){

        $scope.showTabs = $rootScope.showTabs; 
        $scope.activeRoute = $rootScope.activeRoute;
        if(routesWithHanger.indexOf($scope.activeRoute) > -1){
            $scope.hangerIsShown = true;
        }else{
            $scope.hangerIsShown = false;
        }

        if(routesWithoutBackBtn.indexOf($scope.activeRoute) > -1){
            $scope.backBtnIsShown = false;
        }else{
            $scope.backBtnIsShown = true;
        }
        $scope.handleViewContainerTop();
    })

}])

function callMe(i){
    console.log(i)
}