'use strict';


// use angular's idiomatic methods, you can just browserify that single library
//`browserify hello.js -o bundle.js`
//browserify looks at hello.js for calls to require() and bundles the source code into the bundle.js

angular.module('stashd.routes', ['ui.router'])


.config(['$stateProvider', '$urlRouterProvider',
    function($stateProvider, $urlRouterProvider) {

        $urlRouterProvider.otherwise("/intro");
        //$location.path('/product').search('queryStringKey', value).search( ...);
        $stateProvider

            .state('login', {
                url: '/login',
                cache: false,
                // nativeTransitions: null,
                views: {
                    'menuContent': {
                        templateUrl: 'app/core/login/login.html'
                    },

                },
                resolve: {
                    // serverLocatorLoaded: function(ServerLocatorService){
                    //     return ServerLocatorService.serverLocatorLoaded;
                    // },
                    translationsLoaded: function(TranslationsService){
                        return TranslationsService.translationsLoaded;
                    },
                }
                // controller: function ($ionicHistory, $scope) {

                //     console.log($scope);
                //     // $ionicViewSwitcher.nextDirection('forward');
                //     $ionicHistory.nextViewOptions({
                //         historyRoot: true,
                //         disableBack: true
                //     });
                // }


            })
            .state('loginemail', { url: '/login-email',
                nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/login/login-email.html' } } ,
                resolve: {
                    serverLocatorLoaded: function(ServerLocatorService){
                        return ServerLocatorService.serverLocatorLoaded;
                    },
                }
            })

            .state('terms', { url: '/terms',
                nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/terms/terms.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('intro', { url: '/intro',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/login/intro.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
                resolve: {
                    // serverLocatorLoaded: function(ServerLocatorService){
                    //     return ServerLocatorService.serverLocatorLoaded;
                    // },
                    translationsLoaded: function(TranslationsService){
                        return TranslationsService.translationsLoaded;
                    },
                }
            })

            .state('privacy', { url: '/privacy',
                nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/terms/privacy.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('card-demo', { url: '/card-demo',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/demo/card-demo.htm' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })
            .state('store-demo', { url: '/store-demo',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/demo/store-demo.htm' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })
            .state('stylist-demo', { url: '/stylist-demo',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                // nativeTransitionsIOS: null,
                views: { 'menuContent': {
                    templateUrl: 'app/core/demo/stylist-demo.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('registeropt', { url: '/register-opt',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                views: { 'menuContent': {
                    templateUrl: 'app/core/login/register-opt.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })
            .state('forgotpassword', { url: '/forgot-password',
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "left"},
                views: { 'menuContent': {
                    templateUrl: 'app/core/login/forgot-password.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })
            //What does menuContent do?

            .state('cards', { url: '/cards',
                cache: false,
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "down"},
                views: { 'menuContent': {
                    templateUrl: 'app/components/cards/cards.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();                        
                //     }],
                // }
            })

            .state('cardstest', { url: '/cardstest',
                cache: false,
                views: { 'menuContent': {
                    templateUrl: 'app/components/cardstest/cardstest.html' } } ,
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('stores', {
                url: '/stores',
                cache: false,
                // nativeTransitions: {"type": "slide","direction": "up"},
                nativeTransitions: null,
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/stores/stores.html'
                    }
                },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('stylists', {
                url: '/stylists',
                cache: false,
                nativeTransitions: null,
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/stylists/stylists.html'
                    }
                },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })

            .state('wardrobes', {
                 url: '/wardrobes',
                 cache: false,
                 nativeTransitions: null,
                 // nativeTransitions: {"type": "slide","direction": "left"},
                 views: {
                     'menuContent': {
                         templateUrl: 'app/components/wardrobes/wardrobes.html'
                     }
                 },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }                 
            })

            .state('buynow', {
                 url: '/buynow/:buynowlink',
                 cache: false,
                 views: {
                     'menuContent': {
                         templateUrl: 'app/components/buynow/buynow.html'
                     }
                 },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }
            })


            //.state('storeshop', {
            //    url: '/storeshop',
            //    views: {
            //        'menuContent': {
            //            templateUrl: 'app/components/storeshop/storeshop.html'
            //        }
            //    }
            //})

            //.state('product', {
            //    url: '/product/id/{productId:[0-9000000]}',
            //    views: {
            //        'menuContent': {
            //            templateUrl: 'app/components/product/product.html'
            //        }
            //    }
            //})

            .state('menusettings', {
                url: '/menusettings',
                cache: false,
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "right"},
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/menusettings/menusettings.html'
                    }
                },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }                
            })

            .state('product', {
                url: '/product/:product_vari',
                cache: false,
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "down"},
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/product/product.html',
                    },
                },

                resolve: {
                    // authenticated: ['djangoAuth', function(djangoAuth){
                    //     return djangoAuth.authenticationStatus();
                    // }],
                    //productsApi: productsApiProvider
                }
            })

            .state('storeshop', {
                url: '/storeshop/:store_id',
                cache: false,
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "down"},
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/storeshop/storeshop.html'
                    },
                },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }                     
            })

            .state('stylistshop', {
                url: '/stylistshop/:stylist_id',
                cache: false,
                nativeTransitions: null,
                // nativeTransitions: {"type": "slide","direction": "down"},
                views: {
                    'menuContent': {
                        templateUrl: 'app/components/stylistshop/stylistshop.html'
                    }
                },
                // resolve: {
                //     authenticated: ['djangoAuth', function(djangoAuth){
                //         return djangoAuth.authenticationStatus();
                //     }],
                // }                                     
            })
    }
])

    .config(function ($httpProvider) {
        $httpProvider.defaults.headers.common = {};
        $httpProvider.defaults.headers.post = {};
        $httpProvider.defaults.headers.put = {};
        $httpProvider.defaults.headers.patch = {};
        $httpProvider.defaults.headers.get = {};
    })

.directive('noScroll', function($document) {

    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $document.on('touchmove', function(e) {
                e.preventDefault();
            });
        }
    }

function ContentController($scope, $ionSideMenuDelegate) {
  $scope.toggleLeft = function() {
    $ionSideMenuDelegate.toggleLeft();
  };
}

});