angular.module('stashd.card-demo', [])

.config(function($stateProvider, $urlRouterProvider) {

})

.directive('noScroll', function($document) {

    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $document.on('touchmove', function(e) {
                e.preventDefault();
            });
        }
    }
})

//Below analytics needs to be much smarter/better. Should be able to 'update' products, and add to
// numbers. Need to also 'track' movement better. Track js movement?
.factory('cardsdemoApi', ['$http', '$ionicLoading', '$timeout', 'CONFIG', function($http, $ionicLoading, $timeout, CONFIG) {
    var apiUrl = CONFIG.API_URL + '/list/?608';
    // Offline data /app/components/cards/test.json
    var like = JSON.stringify({
        uid: 21,
        click: 1,
        like: 1,
        imagecl: 0,
        removed: 0,
        scroll: 1,
        clickbuy: 0
    });
    var dislike = JSON.stringify({
        uid: 21,
        click: 0,
        like: 0,
        imagecl: 0,
        removed: 0,
        scroll: 0,
        clickbuy: 0
    });

    $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
    });

    var getApiData = function() {
        return $http.get(apiUrl);
        /*.then($ionicLoading.hide, $ionicLoading.hide)*/
        //IF HTTP resonsponse is NOT 200- hide the content
    };

    var postRecordLikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/item/' + product_vari + "/", like);
    }

    var postRecordDislikes = function(product_vari) {
        return $http.post(CONFIG.API_URL + '/item/' + product_vari + "/", dislike);
    }

    return {
        getApiData: getApiData,
        postRecordLikes: postRecordLikes,
        postRecordDislikes: postRecordDislikes,
    };
}])

.controller('CardsdemoCtrl', ['TranslationsService', '$ionicHistory','$location', '$scope', '$rootScope', '$http', '$state', '$q', '$ionicLoading', '$ionicModal', 'TDCardDelegate', 'cardsdemoApi', '$http', '$timeout', '$element', '$ionicPopup',
    function(TranslationsService, $ionicHistory, $location, $scope, $rootScope, $http, $state, $q, $ionicLoading, $ionicModal, TDCardDelegate, cardsdemoApi, $http, $timeout, $element, $ionicPopup) {

$ionicHistory.goBack();

   $scope.translations = TranslationsService.getData();

   $scope.storeAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
       title: 'Oops, you are not logged in',
       template: 'Log in to see your favourite stores'
     });
     alertPopup.then(function(res) {
       console.log('Thank you for not eating my delicious ice cream cone');
     });
   };
   $scope.wardrobeAlert = function(data) {
     var alertPopup = $ionicPopup.alert({
       title: 'Oops, you are not logged in',
       template: 'Log in to save your items in your virtual wardrobe'
     });
     alertPopup.then(function(res) {
       console.log('Thank you for not eating my delicious ice cream cone');
     });
   };


        var loginuid = window.localStorage.getItem('uid');
        console.log(loginuid);


        var MIN_CARDS = 7;
        var CARDS_TO_GET_AT_ONCE = 9; //Currently not working- server to be configured

        console.log('CARDS CTRL');
        $scope.cards = [];

        // <======  Rewrite with accounts preferences
        //  var canceler = $q.defer();
        // $http.get('http://c.cfjump.com/Products/3097/16703688.jpg')
        // .then(function mySuccess(response){
        //     console.log(response.data);
        //     console.log(response.status);
        // }, function myError(response){
        //     console.log(response);
        // });



        cardsdemoApi.getApiData()
            .then(function(result) {
                console.log(result.data); //Shows log of API incoming
                $scope.cards = result.data;


                //$scope.product_vari = result.data.product_vari;

                //HANDLE json field "image"
                //If does NOT load within 4000seconds, ignore that object.
                //If does NOT return a 200
                // For both scenarios, setup a DB that checks images/product availablitiy

                //Wait for the digest cycle...
                //...promise.then(        

                result.data.forEach(function(card) {
                    var imgurl = card.image;
                    console.log(imgurl);
                    var canceler = $q.defer();
                    $http.get(imgurl, {
                            timeout: canceler.promise
                        })
                        .then(function mySuccess(response) {
                            console.log(response.status);
                            //if(response.data = null){$scope.cards.splice(card, 1);}
                            // var imgid = "card-image-" + card.vari;
                            // console.log(imgid);
                            // var img = document.getElementById(imgid);
                            // console.log(img);
                            //img.src = '';
                        }, function myError(response) {
                            console.log(response);

                            $scope.$on("$destroy", function(event){
                                $scope.$destroy();
                            });
                            
                            // console.log('deleted');
                            var imgpid = "#card-image-" + card.vari;
                            console.log(imgpid);
                            $(imgpid).parent().remove();
                        })
                        .catch(function(err) {

                        });
                    $timeout(function() {
                        $ionicLoading.hide();
                        canceler.resolve();
                    }, 4000);


                    // var image = new Image();
                    // //card.loaded = false;
                    // image.src = card.image;
                    // //console.log("test");

                    // var imgElem = document.getElementById('card-image-' + card.vari);

                    // console.log("Card element id=", imgElem);
                    // console.log(card);

                    // image.onload = function () {
                    //     imgElem.src = image.src;

                    //     card.loaded = true;

                    //     $scope.$apply();

                    //     console.log("Yew!");
                    // };

                    // // We still want to hide the loading message if the image fails to load - 404, 401 or network timeout etc
                    // image.onerror = function () {
                    //     console.log("Ooops");
                    // };

                });

            })
            .catch(function(err) {
                //$log.error(err);

            });
        // Rewrite with accounts preferences (from local) =====>

        // $scope.$watchCollection('cards', function(newVal, oldVal) {
        //     if (newVal.length < MIN_CARDS) {
        //         cardsApi.getApiData()
        //             .then(function(result) {

        //                 // console.log(JSON.stringify(result.data)); Shows log of API results

        //                 $scope.cards.unshift(result.data);

        //                 // console.log($scope.cards);

        //             })
        //     }
        // });


        $scope.$watchCollection('cards', function(newVal, oldVal) {
            if (newVal.length < MIN_CARDS) {
                cardsdemoApi.getApiData()
                    .then(function(result) {

                        // console.log(JSON.stringify(result.data)); Shows log of API results

                        $scope.cards.unshift(result.data);
                        console.log("reloaded");

                        var i = 0
                        $scope.cards.forEach(function(card) {                            

                            var cardObj = $("#card-image-" + card.id).parent().parent();            

                            var imageURL = cardObj.find("img").attr("src");

                            if(imageURL == undefined || imageURL.search("c.cfjump.com/") > 0) {    
                                $scope.cards.splice(i, 1); 
                                console.log("====== Deleted id =======" + i);                                   
                            }
                            i++;
                        });

                    })
            }
        });

        $scope.cardDestroyed = function(index) {
            $scope.cards.splice(index, 1);
            fetchMoreIfNeeded();
        };

        function fetchMoreIfNeeded() {
            console.log($scope.cards.length);
            if ($scope.cards.length < MIN_CARDS) {
                console.log("GETTING MORE");
                cardsdemoApi.getApiData(CARDS_TO_GET_AT_ONCE)
                    .then(function(result) {

                        console.log(JSON.stringify(result.data)); //Shows log of API results

                        for (var i = 0; i < result.data.length; i++) {
                            $scope.cards.unshift(result.data[i]);
                        }
                        //$scope.cards. = result.data;

                        console.log($scope.cards);

                    })
                    //.catch(function (err) {
                    //    console.log(err);
                    //});
            }
        }
        $scope.addCard = function() {
            var newCard = $scope.cards[$scope.cards.length];
            //newCard.id = Math.random();
            $scope.cards.push(angular.extend({}, newCard));
        };

        $scope.cardSwipedRight = function(card) {
            console.log('RIGHT');
            postRecordLikes(card);
        };

        var postRecordLikes = function(product_vari) {
            cardsdemoApi.postRecordLikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    console.log(response);
                    if(response.status == 404){
                        $scope.$on("$destroy", function(event){
                            console.log('err');
                            $scope.$destroy();
                        });
                    }
                });
        };

        $scope.cardSwipedLeft = function(card) {
            console.log('LEFT');
            postRecordDislikes(card);
        };

        var postRecordDislikes = function(product_vari) {
            cardsdemoApi.postRecordDislikes(product_vari)
                .then(function successCallback(product_vari) {

                }, function errorCallback(response) {
                    console.log(response);
                    
                });
        };

        $scope.cardevent = function() {
            //window.plugins.flurry.logEvent('CardClick');
        }

        // $ionicModal.fromTemplateUrl('app/components/stores/stores.html', {
        //     scope: $scope,
        //     backdropClickToClose: true,
        //     animation: 'slide-in-up'
        // }).then(function(modal) {
        //     $scope.modal = modal;
        // });

        // $scope.refineevent = function() {
        //     $rootScope.$broadcast('MODAL_IS_SHOWN');
        //     $scope.modal.show();
        // };

        // $scope.closeModal = function() {
        //     $rootScope.$broadcast('MODAL_IS_HIDDEN');
        //     $scope.modal.hide();
        // };

        // $scope.$on('modal.hidden', function() {
        //     $rootScope.$broadcast('MODAL_IS_HIDDEN');
        // });


        // $scope.$on('HIDE_MODAL', function() {$scope.closeModal()});

    }
])

.directive('ifImage', ['$timeout', function($timeout){
    return {
        link: function(scope, element, attr, $timeout) {

            attr.$observe('ifImage', function($timeout) {           
              if (!attr.ifImage) {
                 // No attribute specified, so use default
                 element.css("background-color","black");
                 console.log("red=======red======red");
              } else {
                 var image = new Image();  
                 image.src = attr.ifImage;
                 image.onload = function() { 
                    //Image loaded- set the background image to it
                 };
                 image.onerror = function() {
                    //Image failed to load- use default
                    console.log(element.context.src);
                    var str = element.context.src;
               setTimeout(function(){
                        if(str == '' || str.substr(0, 20) == "http://c.cfjump.com/"){element.parent().parent().remove();}                       
                    }, 4000);
                    //element.parent().remove();
                 };
             }
         });
      }
    };
}])

.directive('ngIf', function() {
    return {
        link: function(scope, element, attrs) {
            if(scope.$eval(attrs.ngIf)) {
                // remove '<div ng-if...></div>'
                //element.replaceWith(element.children())
            } else {
                element.replaceWith(' ');
            }
        }
    }
});